
/*
PANORAMIX
Recepteur panoramique Arduino avec tuner analogique 
visu LCD 128x64 ST7920 et module MCP4725 pour générer une dent de scie
Réalisation décrite sur le site http://f5mna.free.fr
juillet 2014.
*/

#include <U8glib.h> 
#include <Wire.h>
#include <Adafruit_MCP4725.h>

Adafruit_MCP4725 dac;  //SDA Pin A4  SCL Pin A5


U8GLIB_ST7920_128X64_1X u8g(6, 5, 4 ,7); //Enable, RW, RS, RESET

int x,y; 
int Buffer[128]; 


void setup( ) 
{
  u8g.firstPage();
  do {
  u8g.setFont(u8g_font_timB10);
  u8g.drawStr( 15, 20, " RECEPTEUR");
  u8g.drawStr( 10, 40, "PANORAMIQUE");
  u8g.setFont(u8g_font_micro);
  u8g.drawStr( 100, 60, "F5MNA");
 
  //drawline
  u8g.drawLine(0, 0, 127, 0);
  u8g.drawLine(0, 63, 127, 63);
  u8g.drawLine(0, 0, 0, 63);
  u8g.drawLine(127, 0, 127, 63);
 
  } while( u8g.nextPage() );  // reconstruction de la page
   delay(1000);
   dac.begin(0x60); 
  }
// Lecture de la trace
void Trace()  {  
  do
  {
   x += 32;
  dac.setVoltage(x, false);
 
  Buffer[x/32] = analogRead(A0); //Rempli le buffer selon valeurs lues sur l'entrée analogique (A0) de 0 à 5V. 
  Buffer[x/32] = 71-(Buffer[x/32]>>4);//  
   /*Traitement du buffer 
   71 = Positionnement de la trace en bas de l'ecran. Cette valeur
   est à modifier selon tuner utilisé.
   >> 4  >> (bitshift right) ...Divise la valeur binaire par 16 
   Ex: 5V = 1024   = 1024/16 = 64 pixels
   */
  } while (x < 4096);
}

// Affichage de la trace
  void Reticule()
  {
  u8g.setFont(u8g_font_micro);
  u8g.drawStr( 25, 8,"900 MHz --> 1500 MHz" );   
  // Valeur à modifier selon tuner et calibration
  // à l'aide d'un generateur de fréquence.
   
  // Affichage
   for(x = 0; x < 128;x++) 
   u8g.drawLine(x,Buffer[x],x,63); // ligne de pixel à pixel while (x < 1028);
   
  // Reticule
  u8g.drawLine(0,63,128,63); 
  u8g.drawLine(0,0,0,63);
  for(y=13;y<128;y+=17) 
  {
  for(x=16;x<64;x+=8) 
  u8g.drawLine((0+y),x,(y),x);
  u8g.drawFrame(0,0,128,64);
  }
  }
  
  //Principal
    void loop() 
 { Trace();    
   u8g.firstPage();  
   do  Reticule();      
   while( u8g.nextPage()); 
  } 
